/******************************************************************************
 * xtalk - an X implementation of talk
 Copyright (C) 1998  by Christopher Lansdown

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *****************************************************************************/

#include "xtalkd.h"
#include "callbacks.h"

/*****************************************************************************/
/* Begin Global Variables */

GtkWidget *window;
GtkWidget *mainbox;
GtkWidget *text1, *text2, *text3;
GtkWidget *pane;
GtkWidget *input;
int sockfd;
int connected;

/* End Global Variables */
/*****************************************************************************/


int main(int argc, char **argv)
{
    GtkWidget *table;
    GtkWidget *scrollbar;
    GtkWidget *win;
    GtkWidget *box;
    struct sockaddr_in sock_name;
    char name[128];
    int namelen;
    time_t ltime;
    /* Start up gtk */
    gtk_init(&argc, &argv);

    gtk_rc_parse("/etc/xtalkd.gtkrc");

    /* Set the appropriate socket */
    sockfd = 0;
    connected = 1;

    /* Find out who is connecting to us */
    namelen = sizeof(sock_name);
    getpeername(0, &sock_name, &namelen);
    bzero(name, 128);
    ltime = time(NULL);
    sprintf(name, "Xtalk: %s:%i, Started on %s.", inet_ntoa(sock_name.sin_addr), sock_name.sin_port, ctime(&ltime));

    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title(GTK_WINDOW(window), name);
    gtk_widget_set_usize(GTK_WIDGET (window), 640, 480);
    gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, FALSE);
    gtk_signal_connect(GTK_OBJECT (window), "delete_event", 
		       (GtkSignalFunc) gtk_exit, NULL);
    signal(SIGINT, (void *)gtk_main_quit);
/*     gtk_signal_connect (GTK_OBJECT (window), "key_press_event", */
/* 		      GTK_SIGNAL_FUNC(keyevent), NULL); */

    mainbox = gtk_vbox_new(FALSE, 0);
    gtk_widget_show(mainbox);

    gtk_container_add(GTK_CONTAINER (window), mainbox);

    pane = gtk_vpaned_new();
    gtk_widget_show(pane);
    gtk_box_pack_start(GTK_BOX (mainbox), pane, TRUE, TRUE, 0);
    
    /* Set up the terminal text box */
    table = gtk_table_new(2, 2, FALSE);
    text1 = gtk_text_new(NULL, NULL);
    gtk_table_attach(GTK_TABLE (table), text1, 0, 1, 0, 1,
		     GTK_FILL | GTK_EXPAND,
		     GTK_FILL | GTK_EXPAND | GTK_SHRINK, 
		     0, 0);
    gtk_widget_show(text1);
    scrollbar = gtk_vscrollbar_new(GTK_TEXT(text1)->vadj);
    gtk_table_attach(GTK_TABLE (table), scrollbar, 1, 2, 0, 1,
		     GTK_FILL, GTK_EXPAND | GTK_FILL | GTK_SHRINK, 0, 2);
    gtk_widget_show(scrollbar);
    gtk_widget_show(table);
    gtk_paned_add1(GTK_PANED (pane), table);

    /* Set up the X text box */
    table = gtk_table_new(2, 2, FALSE);
    text2 = gtk_text_new(NULL, NULL);
    gtk_text_set_editable(GTK_TEXT (text2), TRUE);
    gtk_signal_connect(GTK_OBJECT(text2), "insert_text",
		       GTK_SIGNAL_FUNC (insert_callback), NULL);
    gtk_signal_connect(GTK_OBJECT(text2), "delete_text",
		       GTK_SIGNAL_FUNC (delete_callback), NULL);

    gtk_table_attach(GTK_TABLE (table), text2, 0, 1, 0, 1,
		     GTK_FILL | GTK_EXPAND,
		     GTK_FILL | GTK_EXPAND | GTK_SHRINK, 
		     0, 0);
    gtk_widget_show(text2);
    scrollbar = gtk_vscrollbar_new(GTK_TEXT(text2)->vadj);
    gtk_table_attach(GTK_TABLE (table), scrollbar, 1, 2, 0, 1,
		     GTK_FILL, GTK_EXPAND | GTK_FILL | GTK_SHRINK, 0, 2);
    gtk_widget_show(scrollbar);
    gtk_widget_show(table);
    gtk_paned_add2(GTK_PANED (pane), table);

    /******************************************/
    /* Begin test */

    win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    box = gtk_hbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(win), box);
    gtk_widget_show(box);
    text3 = gtk_text_new(NULL, NULL);
    gtk_widget_show(text3);
    gtk_box_pack_start(GTK_BOX (box), text3, TRUE, TRUE, 0);
    scrollbar = gtk_vscrollbar_new(GTK_TEXT (text3)->vadj);
    gtk_widget_show(scrollbar);
    gtk_box_pack_start(GTK_BOX (box), scrollbar, FALSE, FALSE, 0);
    gtk_widget_show(win);

    /* End test */
    /******************************************/
					       




    /* Add the input entry area */
    /*
    input = gtk_entry_new();
    gtk_widget_show(input);
    gtk_entry_set_editable(GTK_ENTRY (input), TRUE);
    gtk_box_pack_start(GTK_BOX(mainbox), input, TRUE, TRUE, 0);
    gtk_signal_connect( GTK_OBJECT (input), "activate", GTK_SIGNAL_FUNC (input_callback), input);
    */
   
    gtk_widget_show(window);
    gtk_widget_grab_focus(GTK_WIDGET (text2));
		       
/*     gdk_input_add(0, GDK_INPUT_READ, (GdkInputFunction) text_callback, 0); */
    gdk_input_add(0, GDK_INPUT_READ, (GdkInputFunction) comm_callback, 0);

    gtk_main();
    return 0;
}









